$ !		N E W S S K I M . C O M
$ ! CHANGE THIS CODE WHERE INDICATED TO MATCH YOUR SITE
$ !
$ ! Author:
$ !     G Huston
$ !       Computer Services Centre
$ !       Australian National University
$ !
$ ! Version:
$ !     V1.0    17-Jul-1986
$ !     V2.0    16-Jul-1987
$ !     V4.3    12-Jan-1987     GIH
$ !     V5.2    26-Apr-1988     GIH
$ !     V5.6     3-Nov-1988     GIH
$ !     V5.8     7-Apr-1989     GIH
$ !       - Name change for news groups and items file
$ !     V5.9    15-May-1989     GIH
$ !       - Remove convert/reclaim as it is functionally useless!
$ !
$ ! NEWSSKIM - the daily news management code. This code is submitted into
$ ! the batch queues by account NEWSMGR. NEWSSKIM.COM is set to run at 1:00am
$ ! each day. This does imply that forwarding of news items may incur a 24
$ ! hour delay through this node. YOU MAY WISH TO MODIFY THE FINAL LINES
$ ! OF THIS PROCEDURE TO SUBMIT THIS PROCEDURE A NUMBER OF TIMES THROUGH
$ ! THE DAY.
$ !
$ ! The code performs the following actions:
$ !  1 - read all MAILED items, and add them into NEWS
$ !  2 - delete all expired news items and expired newsgroups
$ !  3 - COPY post items to NEWSMGR proxies on remote DECNET nodes
$ !  4 - resubmit in 24 hours
$ !
$ !**********************************************************************
$ ! SITE SPECIFIC CODE - MODIFY THIS ...
$ ! DEFINE the local OPERATIONS queue by "BATOPER" - sample lines follow
$ !
$   exenode = f$trnlnm("SYS$NODE")
$   if exenode .eqs. "RSBS0::" then $ define batoper newsreader
$   if exenode .eqs. "PHYS0::" then $ define batoper op$batch
$   if exenode .eqs. "CSC1::" then $ define batoper batcsc
$ !**********************************************************************
$ ! start code
$ !
$   on error then goto abort
$   oldprv = f$setprv("SYSPRV")
$   if .not. f$privilege("SYSPRV") then exit
$ !
$ !	Read all and remove locally addressed mail to NEWSMGR
$ !
$   set noon
$   write sys$output "Extracting mailed items"
$   mail
set folder newmail
extract/all news_manager:newmail.mail
delete/all
exit
$ !
$ !	Place all extracted mail into the news data base
$ !
$   rename news_manager:news.batch;* newmail.mail
$   write sys$output "Adding mailed  and forwarded items to news file"
$   news/noscreen
Add Batch/delete news_manager:newmail.mail;*
Add Batch/delete news_manager:news.batch;*
Add Batch/delete news_manager:nntp_*.batch;*
exit
$ !**********************************************************************
$ ! SITE SPECIFIC CODE - MODIFY THIS ...
$ ! If you are running this procedure more than once in a 24 hour period,
$ ! then it is a waste of time to perform more than 1 skim of the NEWS
$ ! files - skip the following section of code in the repeat runs...
$ !
$ !	Skim off all expired news and all new news for posting
$ !
$ skim:
$    write sys$output "Skimming off new and expired items"
$    news/noscreen
skim
exit
$ !**********************************************************************
$ !	Copy news items to other sites
$ !
$ ! Search for all directories of the form news_manager:post_<node>.dir
$ ! Copy all items in the node specific directory to the remote node
$ ! Once all post directories have been found, delete all items in the
$ ! post directory. this code assumes decnet proxies exist on remote
$ ! nodes.
$ !
$ !
$    write sys$output "Copy items to other sites"
$    set on
$ search_1:
$    nodedir = f$search("news_manager:post_*.dir",2)
$    if nodedir .eqs. "" then goto abort
$    node = f$parse(nodedir,,,"NAME","SYNTAX_ONLY") - "POST_"
$    rejectdir = "news_manager_dev:[post_" + node + "];"
$    savedfiles = rejectdir - ";" + "*.*;*"
$    node = node + "::;"
$ search_2:
$        file = f$search(savedfiles,4)
$        if file .eqs. "" then goto search_1
$            cfile = f$element(0,";",file)
$            on error then goto search_2
$            on error then goto no_copy_2
$            copy/log 'file 'node
$            delete 'file
$ no_copy_2:
$        goto search_2
$ !
$ abort:
$ !
$ ! Normal and error exit - schedule newsnet
$ !
$    submit/noprint/queue=batoper/after="tomorrow+1" news_root:newsskim.com
$    x = f$cvtime("TODAY",,"WEEKDAY")
$    if x .nes. "Sunday" then $ goto fin
$    convert news_root:news.groups news_root:news.groups
$    purge news_root:news.groups
$    convert news_root:news.items news_root:news.items
$    purge news_root:news.items
$    convert news_root:history.v60 news_root:history.v60
$    purge news_root:history.v60
$ fin:
$    exit
