X-NEWS: sao.aarnet.edu.au news.software.anu-news: 687
Path: manuel!munnari.oz.au!samsung!zaphod.mps.ohio-state.edu!think.com!mintaka!spdcc!camb.com!tinkelman
From: tinkelman@camb.com (Bob Tinkelman)
Newsgroups: news.software.anu-news
Subject: Posting NNTP-received batches [was RE: News skim /NNTP]
Message-ID: <1991Apr6.190617.39663@camb.com>
Date: 7 Apr 91 00:06:17 GMT
References: <1991Apr4.103127.7658@cc.curtin.edu.au>
Organization: Cambridge Computer Associates, Inc.
Lines: 94

In article <1991Apr4.103127.7658@cc.curtin.edu.au>, chooper@cc.curtin.edu.au
(Todd Hooper) writes:
> 
> My understanding of nntp_xmit is that they initiate a connection to our nntp
> server, and the resultant news batch files turn up in news_manager. I then
> have to schedule a newsadd job to add these to the database right? How does
> the newsadd job know when to come in and process the batch files - is there
> some sort of concurrency problem here?

What we do here is to run an hourly batch job (submitted by cron) which builds
a com file with ADD FILE news commands for each nntp*.batch file.  It then
invokes that file which itself invokes the NEWS image just once.  This seemed
to help a lot, compared with invoking NEWS once for each batch file.  With a
full news feed on a microVAX II and slow RRDxx drives, this hourly job runs
approximately 15-20 minutes.  I've attached a copy of this file.  [The cron
command file which submits it passes it (as an argument) the current time.]

1 hour isn't magic.  It's just what was convenient with cron (which I prefer
to self-resubmitting batch jobs).
-- 
Bob Tinkelman, Cambridge Computer Associates, Inc., 212-425-5830, bob@camb.com

$!---------------------------------- CUT HERE ----------------------------------
$! Received_NNTP.com --	Add to news the nntp_*.batch files that have 
$!			accumulated, and which were received before
$!			a(n optionally) specifed cutoff time.  [P1]
$
$! Set up defaults for the run
$
$	NNTP_File_Spec :== "news_manager:nntp*.batch"
$	On Error then GoTo All_Done
$
$! Make a unique name for the temp file
$
$	facility = F$Parse(F$Environment("PROCEDURE"),,,"NAME")
$	facility = F$Edit(facility,"lowercase")
$	tmp_file = "sys$scratch:"+f$getjpi("","PID")+"$"+facility+".tmp"
$
$! Set Batch Job Process name to be facility name
$
$	If F$Mode() .eqs. "BATCH" then Set Proc/Name="''Facility'"
$
$! Quick Check to see if any work to do;  exit if none
$
$	If F$Search(NNTP_File_Spec) .eqs. "" then GoTo All_Done
$
$! If no cutoff time specified, use the current time.
$
$	Cutoff_Time = P1
$	If Cutoff_Time .eqs. "" then Cutoff_Time = F$Time()
$
$! Reset Process Name to include cutoff time
$
$	HHMM = F$Extract(F$Locate(":",Cutoff_Time)-2,5,Cutoff_Time)
$	Process_Name = "nntp <= ''HHMM'"
$	If F$Mode() .eqs. "BATCH" then Set Proc/Name="''Process_Name'"
$
$! Control use of NEWS ADD FILE/EXECUTE switch with NEWS_EXECUTE_CONTROL logical
$
$	If (F$Logi("News_Execute_Control")) 
$	    Then 
$		ExecQual = "/Execute"
$	    Else 
$		ExecQual = ""
$	    EndIf
$
$! Open and start writing to the tmp file
$
$	On Error then GoTo Close_Up
$	Open/Write M 'tmp_file'
$	Write      M "$news/noscreen"
$
$! Look for `old' files to be processed
$
$	Num_Files = 0
$Loop:
$	File = F$Search(NNTP_File_Spec,1) 
$	If File .eqs. "" then GoTo Loop_X
$	File_Create_Time = F$File_Attributes(File,"cdt")
$	If F$CvTime(File_Create_Time) .lts. F$CvTime(Cutoff_Time)
$	Then
$	    Write M "Add File /Delete ''ExecQual' ''File'"
$	    Num_Files = Num_Files + 1
$	EndIf
$	GoTo Loop
$Loop_X:
$
$Close_Up:
$	Write M "Quit"
$	Close M
$	If Num_Files .gt.1 then @'tmp_file'
$	Delete 'tmp_file';*
$All_Done:
$!---------------------------------- CUT HERE ----------------------------------
